package ru.nsu.sberlab.model.mapper;

import lombok.RequiredArgsConstructor;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Component;
import ru.nsu.sberlab.model.dto.user.UserRegistrationDto;
import ru.nsu.sberlab.model.entity.User;

import java.util.function.Function;

@Component
@RequiredArgsConstructor
public class UserMapper implements Function<UserRegistrationDto, User> {
    private final PasswordEncoder passwordEncoder;

    @Override
    public User apply(UserRegistrationDto registrationDto) {
        return new User(
                registrationDto.getFirstName(),
                registrationDto.getEmail(),
                registrationDto.getPhoneNumber(),
                passwordEncoder.encode(registrationDto.getPassword()),
                registrationDto.isHasPermitToShowEmail(),
                registrationDto.isHasPermitToShowPhoneNumber()
        );
    }
}
